/*
 * LaunchPad 1.11 public code release - October 1, 1997
 *  Official LaunchPad page: http://www.nwlink.com/~emilyk/LaunchPad
 *
 *  This code compiles with the EXCELLENT GCC 0.4.0 Win32 port for PalmPilot.
 *  Find info about it at http://www.shoppersmart.com/jlehett/gccwin32.html
 *  Does not compile under the 0.5.0 port because of PalmOS 2.0 differences.
 *
 * Disclaimers and other legal stuff:
 *  This code is provided AS-IS; there is NO WARRANTY, express or implied.
 *  The user assumes full responsibility and liability for any use of
 *  this code.
 *
 *  Copyright (C)1997 Eric Kenslow.
 *  All Rights Reserved by Eric Kenslow, except as noted below.
 *
 *  Permission to distribute this package complete and unmodified
 *  for personal use via the internet for no charge (other than reasonable
 *  connection charges) is granted to the public.
 *  Distribution for commercial purposes via any other medium, including but
 *  not limited to CD-ROM, floppy, or printed material, in whole or in part,
 *  requires express permission from Eric Kenslow (erick@metainfo.com).
 *
 *  Modified versions may be distributed with this notice intact, provided
 *  that said versions are clearly marked as modified code. The above
 *  provisions also apply to any such modified packages.
 *
 *  Permission is also granted to the public to use PARTS of this code in
 *  other projects, with no special notice required unless the source code
 *  is part of the distribution, in which case this notice must remain
 *  conspicuous in the code that was used.
 *
 * Note: These terms are intended to protect me, not make this package less
 *       useful. If you have a special need or use for this package, contact
 *       me and we'll work something out.
 *                                                - Eric
 *                                                  erick@metainfo.com
 *
 */


/*****************************************************************************
*
*   Header name:  LaunchPad
*   Project:      LaunchPad
*
*   Created:      3/29/1997  Eric Kenslow
*
*   Description:  Global interfaces
*
*****************************************************************************/

#ifndef LaunchPad_h
#define LaunchPad_h

// Global includes
#pragma pack( 2 )
#include <Pilot.h>

// Global events
enum  enumLauncherEvents
{
  nextTabEvent = firstUserEvent,
};

// Global macros/constants
#define g_dwCreatorID   ((ULong)'LcPd')
#define g_dwVersion     ((int)0x0101)

#define g_cbmaxTabName  ((Word)12)

enum { g_iFtrOldTrap, g_iFtrRefresh,
        g_iFtrPrevAppIDDB, g_iFtrPrevAppICard };

// Global types

typedef struct tagPrefs
{
  Byte    iTabCur;

  struct tagBoolFlags
    {
    unsigned  int fPlaceHolderUnused  : 1;  // Formerly auto-detect apps

    unsigned  int fDragKeepsTab  : 1;
    unsigned  int fStartOnTab0   : 1;
    unsigned  int fPageScroll    : 1;
    unsigned  int fGadgetsUnused : 1; // No longer used

enum { timeTime, timeDate, timeDayOfWeek, timeMax };
    unsigned  int fShowDate      : 3;
enum { voltVolt, voltBar, voltMax };
    unsigned  int fShowBar       : 3;

    unsigned  int fCycleTime     : 1;
    unsigned  int fCycleVolt     : 1;

    unsigned  int fDefaultLauncher : 1;
    } flags;

  struct tagBitData
    {
    unsigned  int cAppColumns    : 3;

    unsigned  int cSecCycleTime  : 5;
    unsigned  int cSecCycleVolt  : 5;
    } data;

  int     dxTabScroll;

  VoidPtr pOldAppTrap;

  Byte    maskGadgets;

  // Padding, to allow room for future expansion without deleting LaunchPad
  Byte    reserved  [ 32 - sizeof( Byte ) -
                      sizeof( struct tagBoolFlags ) -
                      sizeof( struct tagBitData ) -
                      sizeof( int ) -
                      sizeof( VoidPtr ) -
                      sizeof( Byte ) ];
} LauncherPrefsType, *LauncherPrefsPtr;

// Global data

extern  volatile  LauncherPrefsType g_prefs;

// Form callbacks
 // From mainform.c
Boolean MainFormHandler     ( EventPtr );
 // From about.c
Boolean AboutFormHandler    ( EventPtr );
 // From prefs.c
Boolean PrefsFormHandler    ( EventPtr );
 // From tabforms.c
Boolean RenameFormHandler   ( EventPtr );
Boolean NewTabFormHandler   ( EventPtr );

// Global APIs
 // From WinMan.c
Boolean WinManInit          ( void );
void    WinManCleanup       ( void );

 // From AppMan.c
Boolean AppManInit          ( RectanglePtr prcAppWindow );
void    AppManCleanup       ( void );
void    AppManRecalcRects   ( void );
void    AppManDrawApps      ( void );
Boolean AppManHitTest       ( SWord x, SWord y, Boolean fDownStroke );
Boolean AppManLaunchLast    ( void );
Boolean AppManScroll        ( DirectionType );
Boolean AppManCanScroll     ( DirectionType );
Boolean AppManMoveLast      ( Byte iTabNew );
void    AppManClearTab      ( void );
void    AppManDrag          ( SWord x, SWord y );
void    AppManMoveTab       ( Byte iTabOld, Byte iTabNew );

 // From Database.c
Boolean DBInit              ( void );
void    DBCleanup           ( void );
typedef enum  enumDBType  { apps = 0, tabs, cDBs, maxDB = cDBs } DBIndexType;
VoidPtr DBGetRecord         ( DBIndexType, UInt iRec );
#define dbAddAtEnd          ((UInt)-1)
Boolean DBAddRecord         ( DBIndexType, UIntPtr piRec, VoidPtr, ULong cb );
void    DBReleaseRecord     ( DBIndexType, UInt iRec, VoidPtr precToUnlock );
void    DBDeleteRecord      ( DBIndexType, UInt iRec );
UInt    DBRecordCount       ( DBIndexType );
void    DBMoveRecord        ( DBIndexType, UInt iFrom, UInt iTo );

 // From Prefs.c
void    PrefsHookApps       ( void );

 // From TabMan.c
void    TabManDrawTabs      ( void );
Byte    TabManHitTest       ( SWord x, SWord y );
Boolean TabManDelete        ( void );
CharPtr TabManGetName       ( void );
void    TabManSetName       ( CharPtr );
Boolean TabManNewTab        ( CharPtr );
void    TabManNextTab       ( void );
void    TabManDrag          ( SWord x, SWord y );
void    TabManMoveTab       ( Byte iOldPos, Byte iNewPos );
Boolean TabManScroll        ( DirectionType );
Boolean TabManCanScroll     ( DirectionType );

#endif /* LaunchPad_h */

