/*
 * LaunchPad 1.11 public code release - October 1, 1997
 *  Official LaunchPad page: http://www.nwlink.com/~emilyk/LaunchPad
 *
 *  This code compiles with the EXCELLENT GCC 0.4.0 Win32 port for PalmPilot.
 *  Find info about it at http://www.shoppersmart.com/jlehett/gccwin32.html
 *  Does not compile under the 0.5.0 port because of PalmOS 2.0 differences.
 *
 * Disclaimers and other legal stuff:
 *  This code is provided AS-IS; there is NO WARRANTY, express or implied.
 *  The user assumes full responsibility and liability for any use of
 *  this code.
 *
 *  Copyright (C)1997 Eric Kenslow.
 *  All Rights Reserved by Eric Kenslow, except as noted below.
 *
 *  Permission to distribute this package complete and unmodified
 *  for personal use via the internet for no charge (other than reasonable
 *  connection charges) is granted to the public.
 *  Distribution for commercial purposes via any other medium, including but
 *  not limited to CD-ROM, floppy, or printed material, in whole or in part,
 *  requires express permission from Eric Kenslow (erick@metainfo.com).
 *
 *  Modified versions may be distributed with this notice intact, provided
 *  that said versions are clearly marked as modified code. The above
 *  provisions also apply to any such modified packages.
 *
 *  Permission is also granted to the public to use PARTS of this code in
 *  other projects, with no special notice required unless the source code
 *  is part of the distribution, in which case this notice must remain
 *  conspicuous in the code that was used.
 *
 * Note: These terms are intended to protect me, not make this package less
 *       useful. If you have a special need or use for this package, contact
 *       me and we'll work something out.
 *                                                - Eric
 *                                                  erick@metainfo.com
 *
 */


/*****************************************************************************
*
*   Module name:  TabForms
*   Project:      LaunchPad
*
*   Created:      4/12/1997  Eric Kenslow
*
*   Description:  Form procs for the tab-related forms
*
*****************************************************************************/

#include "LaunchPad.h"
#include "res.h"
#include <graffiti.h>

/*** RenameFormHandler *******************************************************
*
*   Purpose:   Handles the tab rename form
*
*   Returns:   true if the event was fully handled
*
*   Created:   4/12/1997  Eric Kenslow
*****************************************************************************/

Boolean RenameFormHandler( EventPtr pevt )
{
  Boolean fHandled = true;
  FormPtr pMe = FrmGetActiveForm();
  static  VoidHand  hName;

  switch( pevt->eType )
    {
    case frmOpenEvent:
      {
      FieldPtr  pfld = FrmGetObjectPtr( pMe,
                        FrmGetObjectIndex( pMe, idTabName ) );
      hName = MemHandleNew( g_cbmaxTabName );
      StrCopy( MemHandleLock( hName ), TabManGetName() );
      MemHandleUnlock( hName );
      FldSetTextHandle( pfld, (Handle)hName );

      FrmDrawForm( pMe );
      FrmSetFocus( pMe, FrmGetObjectIndex( pMe, idTabName ) );
      break;
      }

    case ctlSelectEvent:
      {
      switch( pevt->data.ctlSelect.controlID )
        {
        case idOK:
          TabManSetName( MemHandleLock( hName ) );
          MemHandleUnlock( hName );
          FrmUpdateForm( idFormMain, 0 );
          break;

        case idCancel:
          break;
        }

      FrmReturnToForm( 0 );
      break;
      }

    default:
      fHandled = false;
      break;
    }

  return fHandled;
}

/*** NewTabFormHandler *******************************************************
*
*   Purpose:   Handles the tab NewTab form
*
*   Returns:   true if the event was fully handled
*
*   Created:   4/13/1997  Eric Kenslow
*****************************************************************************/

Boolean NewTabFormHandler( EventPtr pevt )
{
  Boolean fHandled = true;
  FormPtr pMe = FrmGetActiveForm();
  static  VoidHand  hName;

  switch( pevt->eType )
    {
    case frmOpenEvent:
      {
      FieldPtr  pfld = FrmGetObjectPtr( pMe,
                        FrmGetObjectIndex( pMe, idTabName ) );
      hName = MemHandleNew( g_cbmaxTabName );
      MemSet( MemHandleLock( hName ), g_cbmaxTabName, 0 );
      MemHandleUnlock( hName );
      FldSetTextHandle( pfld, (Handle)hName );

      FrmDrawForm( pMe );
      FrmSetFocus( pMe, FrmGetObjectIndex( pMe, idTabName ) );
      GrfSetState( false, false, true );

      break;
      }

    case ctlSelectEvent:
      {
      switch( pevt->data.ctlSelect.controlID )
        {
        case idOK:
          if( !TabManNewTab( MemHandleLock( hName ) ) )
            SndPlaySystemSound( sndError );
          MemHandleUnlock( hName );
          FrmUpdateForm( idFormMain, 0 );
          break;

        case idCancel:
          break;
        }

      FrmReturnToForm( 0 );
      break;
      }

    default:
      fHandled = false;
      break;
    }

  return fHandled;
}

