/*
 * LaunchPad 1.11 public code release - October 1, 1997
 *  Official LaunchPad page: http://www.nwlink.com/~emilyk/LaunchPad
 *
 *  This code compiles with the EXCELLENT GCC 0.4.0 Win32 port for PalmPilot.
 *  Find info about it at http://www.shoppersmart.com/jlehett/gccwin32.html
 *  Does not compile under the 0.5.0 port because of PalmOS 2.0 differences.
 *
 * Disclaimers and other legal stuff:
 *  This code is provided AS-IS; there is NO WARRANTY, express or implied.
 *  The user assumes full responsibility and liability for any use of
 *  this code.
 *
 *  Copyright (C)1997 Eric Kenslow.
 *  All Rights Reserved by Eric Kenslow, except as noted below.
 *
 *  Permission to distribute this package complete and unmodified
 *  for personal use via the internet for no charge (other than reasonable
 *  connection charges) is granted to the public.
 *  Distribution for commercial purposes via any other medium, including but
 *  not limited to CD-ROM, floppy, or printed material, in whole or in part,
 *  requires express permission from Eric Kenslow (erick@metainfo.com).
 *
 *  Modified versions may be distributed with this notice intact, provided
 *  that said versions are clearly marked as modified code. The above
 *  provisions also apply to any such modified packages.
 *
 *  Permission is also granted to the public to use PARTS of this code in
 *  other projects, with no special notice required unless the source code
 *  is part of the distribution, in which case this notice must remain
 *  conspicuous in the code that was used.
 *
 * Note: These terms are intended to protect me, not make this package less
 *       useful. If you have a special need or use for this package, contact
 *       me and we'll work something out.
 *                                                - Eric
 *                                                  erick@metainfo.com
 *
 */


/*****************************************************************************
*
*   Module name:  WinMan
*   Project:      LaunchPad
*
*   Created:      3/30/1997  Eric Kenslow
*
*   Description:  Code & data for the window manager
*
*****************************************************************************/

#include "LaunchPad.h"

// Prototypes for global functions that only we call
 // From TabMan.c
Boolean TabManInit    ( RectanglePtr );
void    TabManCleanup ( void );

// End global prototypes

// Modular macros & constants

#define mg_dxApps ((int)0)
#define mg_dyApps ((int)15)
#define mg_cxApps ((int)160)
#define mg_cyApps ((int)149 - mg_dyApps)

// End modular macros

/*** WinManInit **************************************************************
*
*   Purpose:   Initializes the window system
*
*   Returns:   true if successful
*
*   Created:   3/30/1997  Eric Kenslow
*****************************************************************************/

Boolean WinManInit( void )
{
  Boolean fSuccess = true;
  RectangleType rc;

  RctSetRectangle( &rc, 3, 1, 140, mg_dyApps - 1 );
  fSuccess = fSuccess && TabManInit( &rc );
  RctSetRectangle( &rc, mg_dxApps, mg_dyApps, mg_cxApps, mg_cyApps );
  fSuccess = fSuccess && AppManInit( &rc );

  return fSuccess;
}

/*** WinManCleanup ***********************************************************
*
*   Purpose:   Cleans up after the window system
*
*   Returns:   Nothing
*
*   Created:   3/30/1997  Eric Kenslow
*****************************************************************************/

void WinManCleanup( void )
{
  AppManCleanup();
  TabManCleanup();
}

